searchNodes=[{"doc":"Module handling ldap requests and translate them to the :eldap syntax. Configuration The configuration should be in the dev.secret.exs or prod.secret.exs depending on the environment you're working on. Here's an example config: config :penguin_paddle , Paddle , host : &quot;ldap.my-organisation.org&quot; , base : &quot;dc=myorganisation,dc=org&quot; , ssl : true , port : 636 , ipv6 : true , tcpopts : [ ] , sslopts : [ certfile : &#39;/path/to/certificate.crt&#39; ] , timeout : 3000 , account_subdn : &quot;ou=People&quot; , schema_files : Path . wildcard ( &quot;/etc/openldap/schema/*.schema&quot; ) , filter_passwords : true Option Description Default :host The host(s) containing the LDAP server(s). Can be a bitstring for a single host, or a list of bitstrings, which will make Paddle try to connect to each host in the specified order. See also the :timeout option. Mandatory :base The base DN. &quot;&quot; :ssl When set to true , use SSL to connect to the LDAP server. false :port The port the LDAP server listen to. 389 :ipv6 When set to true , connect to the LDAP server using IPv6. false :tcpopts Additionnal :gen_tcp.connect/4 / :ssl.connect/4 options. Must not have the :active , :binary , :deliver , :list , :mode or :packet options. See :gen_tcp 's option documentation . [] :sslopts Additionnal :ssl.connect/4 options. Ineffective if the :ssl option is set to false . See :ssl 's option documentation . [] :timeout The timeout in milliseconds, or nil for the default TCP stack timeout value (which may be very long), for each request to the LDAP server. nil :account_subdn The DN (without the base) where the accounts are located. Used by the Paddle.authenticate/2 function. &quot;ou=People&quot; :account_identifier The identifier by which users are identified. Used by the Paddle.authenticate/2 function. :uid :schema_files Files which are to be parsed to help generate classes using Paddle.Class.Helper . [] :filter_passwords Filter passwords from appearing in the logs true Usage To check a user's credentials and/or authenticate the connection, simply do: Paddle . authenticate ( &quot;username&quot; , &quot;password&quot; ) You can also specify the partial DN like so: Paddle . authenticate ( [ cn : &quot;admin&quot; ] , &quot;adminpassword&quot; ) Many functions support passing both a base and a filter via a keyword list or a map like so: Paddle . get ( filter : [ uid : &quot;testuser&quot; ] , base : [ ou : &quot;People&quot; ] ) But you can also use structs which implements the Paddle.Class protocol (called class objects ). If we take as example the classes defined in test/support/classes.ex , we could do: Paddle . get % MyApp.PosixAccount { uid : &quot;user&quot; } The previous example will return every accounts which are in a given subDN (defined in the Paddle.Class protocol), which have the right objectClass (also defined in the same protocol), and have an uid of &quot;user&quot;. You can also specify an additional filter as second argument. Class objects A class object is simply a struct implementing the Paddle.Class protocol. If you're in need of some examples, you can see the test/support/classes.ex file which defines MyApp.PosixAccount , and MyApp.PosixGroup (but only in test mode, so you would have to define your own). For more informations, see the Paddle.Class module documentation. Filters A filter in Paddle is a keyword list or a map. This is equivalent to a filter where each attribute name (key from the map / keyword list) must have a corresponding value (value from the map / keyword list). Example: [ uid : &quot;user&quot; , cn : &quot;User&quot; , homeDirectory : &quot;/home/user&quot; ] If you are missing some filtering capabilities, you can always pass as argument an :eldap filter like so: Paddle . get ( filter : :eldap . substrings ( &#39;uid&#39; , initial : &#39;b&#39; ) ) For more informations and examples, see Paddle.Filters.construct_filter/1 Bases A base in Paddle can be a Keyword list that will be converted to a charlist to be passed on to the :eldap module. A direct string can also be passed. For more informations and examples, see Paddle.Filters.construct_dn/2","ref":"Paddle.html","title":"Paddle","type":"module"},{"doc":"Add an entry to the LDAP given a class object. Example: Paddle . add ( % MyApp.PosixAccount { uid : &quot;myUser&quot; , cn : &quot;My User&quot; , gidNumber : &quot;501&quot; , homeDirectory : &quot;/home/myUser&quot; } )","ref":"Paddle.html#add/1","title":"Paddle.add/1","type":"function"},{"doc":"Add an entry to the LDAP given a DN and a list of attributes. The first argument is the DN given as a string or keyword list. The second argument is the list of attributes in the new entry as a keyword list like so: [ objectClass : [ &quot;account&quot; , &quot;posixAccount&quot; ] , cn : &quot;User&quot; , loginShell : &quot;/bin/bash&quot; , homeDirectory : &quot;/home/user&quot; , uidNumber : 501 , gidNumber : 100 ] Please note that due to the limitation of char lists you cannot pass directly a char list as an attribute value. But, you can wrap it in an array like this: homeDirectory: ['/home/user']","ref":"Paddle.html#add/2","title":"Paddle.add/2","type":"function"},{"doc":"Check the given credentials and authenticate the current connection. When given the wrong credentials, returns {:error, :invalidCredentials} The user id can be passed as a binary, which will expand to &lt;account_identifier&gt;=&lt;id&gt;,&lt;account subdn&gt;,&lt;base&gt; , or with a keyword list if you want to specify the whole DN (but still without the base DN). Example: iex&gt; Paddle . authenticate ( &quot;testuser&quot; , &quot;test&quot; ) :ok iex&gt; Paddle . authenticate ( &quot;testuser&quot; , &quot;wrong password&quot; ) { :error , :invalidCredentials } iex&gt; Paddle . authenticate ( [ cn : &quot;admin&quot; ] , &quot;test&quot; ) :ok","ref":"Paddle.html#authenticate/2","title":"Paddle.authenticate/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Paddle.html#child_spec/1","title":"Paddle.child_spec/1","type":"function"},{"doc":"Get the whole configuration of the Paddle application.","ref":"Paddle.html#config/0","title":"Paddle.config/0","type":"function"},{"doc":"Get the environment configuration of the Paddle application under a certain key.","ref":"Paddle.html#config/1","title":"Paddle.config/1","type":"function"},{"doc":"Same as config/1 but allows you to specify a default value.","ref":"Paddle.html#config/2","title":"Paddle.config/2","type":"function"},{"doc":"Delete a LDAP entry given a DN or a class object. Examples: Paddle . delete ( &quot;uid=testuser,ou=People&quot; ) Paddle . delete ( [ uid : &quot;testuser&quot; , ou : &quot;People&quot; ] ) Paddle . delete ( % MyApp.PosixAccount { uid : &quot;testuser&quot; } ) The three examples above do exactly the same thing (provided that the MyApp.PosixAccount is configured appropriately).","ref":"Paddle.html#delete/1","title":"Paddle.delete/1","type":"function"},{"doc":"Get one or more LDAP entries given a partial DN and a filter. Example: iex&gt; Paddle . get ( base : [ uid : &quot;testuser&quot; , ou : &quot;People&quot; ] ) { :ok , [ %{ &quot;cn&quot; =&gt; [ &quot;Test User&quot; ] , &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;gecos&quot; =&gt; [ &quot;Test User,,,,&quot; ] , &quot;gidNumber&quot; =&gt; [ &quot;120&quot; ] , &quot;homeDirectory&quot; =&gt; [ &quot;/home/testuser&quot; ] , &quot;loginShell&quot; =&gt; [ &quot;/bin/bash&quot; ] , &quot;objectClass&quot; =&gt; [ &quot;account&quot; , &quot;posixAccount&quot; , &quot;top&quot; ] , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] , &quot;uidNumber&quot; =&gt; [ &quot;500&quot; ] , &quot;userPassword&quot; =&gt; [ &quot;{SSHA}AIzygLSXlArhAMzddUriXQxf7UlkqopP&quot; ] } ] } iex&gt; Paddle . get ( base : &quot;uid=testuser,ou=People&quot; ) { :ok , [ %{ &quot;cn&quot; =&gt; [ &quot;Test User&quot; ] , &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;gecos&quot; =&gt; [ &quot;Test User,,,,&quot; ] , &quot;gidNumber&quot; =&gt; [ &quot;120&quot; ] , &quot;homeDirectory&quot; =&gt; [ &quot;/home/testuser&quot; ] , &quot;loginShell&quot; =&gt; [ &quot;/bin/bash&quot; ] , &quot;objectClass&quot; =&gt; [ &quot;account&quot; , &quot;posixAccount&quot; , &quot;top&quot; ] , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] , &quot;uidNumber&quot; =&gt; [ &quot;500&quot; ] , &quot;userPassword&quot; =&gt; [ &quot;{SSHA}AIzygLSXlArhAMzddUriXQxf7UlkqopP&quot; ] } ] } iex&gt; Paddle . get ( base : [ uid : &quot;nothing&quot; ] ) { :error , :noSuchObject } iex&gt; Paddle . get ( filter : [ uid : &quot;testuser&quot; ] , base : [ ou : &quot;People&quot; ] ) { :ok , [ %{ &quot;cn&quot; =&gt; [ &quot;Test User&quot; ] , &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;gecos&quot; =&gt; [ &quot;Test User,,,,&quot; ] , &quot;gidNumber&quot; =&gt; [ &quot;120&quot; ] , &quot;homeDirectory&quot; =&gt; [ &quot;/home/testuser&quot; ] , &quot;loginShell&quot; =&gt; [ &quot;/bin/bash&quot; ] , &quot;objectClass&quot; =&gt; [ &quot;account&quot; , &quot;posixAccount&quot; , &quot;top&quot; ] , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] , &quot;uidNumber&quot; =&gt; [ &quot;500&quot; ] , &quot;userPassword&quot; =&gt; [ &quot;{SSHA}AIzygLSXlArhAMzddUriXQxf7UlkqopP&quot; ] } ] }","ref":"Paddle.html#get/1","title":"Paddle.get/1","type":"function"},{"doc":"Get an entry in the LDAP given a class object. You can specify an optional additional filter as second argument. Example: iex&gt; Paddle . get ( % MyApp.PosixAccount { } ) { :ok , [ % MyApp.PosixAccount { cn : [ &quot;Test User&quot; ] , description : nil , gecos : [ &quot;Test User,,,,&quot; ] , gidNumber : [ &quot;120&quot; ] , homeDirectory : [ &quot;/home/testuser&quot; ] , host : nil , l : nil , loginShell : [ &quot;/bin/bash&quot; ] , o : nil , ou : nil , seeAlso : nil , uid : [ &quot;testuser&quot; ] , uidNumber : [ &quot;500&quot; ] , userPassword : [ &quot;{SSHA}AIzygLSXlArhAMzddUriXQxf7UlkqopP&quot; ] } ] } iex&gt; Paddle . get ( % MyApp.PosixGroup { cn : &quot;users&quot; } ) { :ok , [ % MyApp.PosixGroup { cn : [ &quot;users&quot; ] , description : nil , gidNumber : [ &quot;2&quot; ] , memberUid : [ &quot;testuser&quot; ] , userPassword : nil } ] } iex&gt; Paddle . get ( % MyApp.PosixGroup { } , :eldap . substrings ( &#39;cn&#39; , initial : &#39;a&#39; ) ) { :ok , [ % MyApp.PosixGroup { cn : [ &quot;adm&quot; ] , description : nil , gidNumber : [ &quot;3&quot; ] , memberUid : nil , userPassword : nil } ] }","ref":"Paddle.html#get/2","title":"Paddle.get/2","type":"function"},{"doc":"Same as get/1 but throws in case of an error.","ref":"Paddle.html#get!/1","title":"Paddle.get!/1","type":"function"},{"doc":"Same as get/2 but throws in case of an error.","ref":"Paddle.html#get!/2","title":"Paddle.get!/2","type":"function"},{"doc":"Get the DN of an entry. Example: iex&gt; Paddle . get_dn ( % MyApp.PosixAccount { uid : &quot;testuser&quot; } ) { :ok , &quot;uid=testuser,ou=People&quot; }","ref":"Paddle.html#get_dn/1","title":"Paddle.get_dn/1","type":"function"},{"doc":"Get a single LDAP entry given an optional partial DN and an optional filter. Example: iex&gt; Paddle . get_single ( base : [ ou : &quot;People&quot; ] ) { :ok , %{ &quot;dn&quot; =&gt; &quot;ou=People&quot; , &quot;objectClass&quot; =&gt; [ &quot;top&quot; , &quot;organizationalUnit&quot; ] , &quot;ou&quot; =&gt; [ &quot;People&quot; ] } } iex&gt; Paddle . get_single ( filter : [ uid : &quot;nothing&quot; ] ) { :error , :noSuchObject }","ref":"Paddle.html#get_single/1","title":"Paddle.get_single/1","type":"function"},{"doc":"Modify an LDAP entry given a DN or a class object and a list of modifications. A modification is specified like so: { action , { parameters ... } } Available modifications: {:add, {field, value}} {:delete, field} {:replace, {field, value}} For example, adding a &quot;description&quot; field: { :add , { &quot;description&quot; , &quot;This is a description&quot; } } This allows you to do things like this: Paddle . modify ( [ uid : &quot;testuser&quot; , ou : &quot;People&quot; ] , add : { &quot;description&quot; , &quot;This is a description&quot; } , delete : &quot;gecos&quot; , replace : { &quot;o&quot; , [ &quot;Club *Nix&quot; , &quot;Linux Foundation&quot; ] } ) Or, using class objects: Paddle . modify ( % MyApp.PosixAccount { uid : &quot;testuser&quot; } , add : { &quot;description&quot; , &quot;This is a description&quot; } , delete : &quot;gecos&quot; , replace : { &quot;o&quot; , [ &quot;Club *Nix&quot; , &quot;Linux Foundation&quot; ] } )","ref":"Paddle.html#modify/2","title":"Paddle.modify/2","type":"function"},{"doc":"Closes the current connection and opens a new one. Accepts connection information as arguments. Not specified values will be fetched from the config. Example: iex&gt; Paddle . reconnect ( host : [ &#39;example.com&#39; ] ) { :error , { :not_connected , &quot;connect failed&quot; } } iex&gt; Paddle . reconnect ( ) { :ok , :connected }","ref":"Paddle.html#reconnect/1","title":"Paddle.reconnect/1","type":"function"},{"doc":"","ref":"Paddle.html#t:add_ldap_error/0","title":"Paddle.add_ldap_error/0","type":"type"},{"doc":"","ref":"Paddle.html#t:attributes/0","title":"Paddle.attributes/0","type":"type"},{"doc":"","ref":"Paddle.html#t:auth_status/0","title":"Paddle.auth_status/0","type":"type"},{"doc":"","ref":"Paddle.html#t:authenticate_ldap_error/0","title":"Paddle.authenticate_ldap_error/0","type":"type"},{"doc":"","ref":"Paddle.html#t:delete_ldap_error/0","title":"Paddle.delete_ldap_error/0","type":"type"},{"doc":"","ref":"Paddle.html#t:dn/0","title":"Paddle.dn/0","type":"type"},{"doc":"","ref":"Paddle.html#t:ldap_entry/0","title":"Paddle.ldap_entry/0","type":"type"},{"doc":"","ref":"Paddle.html#t:mod/0","title":"Paddle.mod/0","type":"type"},{"doc":"","ref":"Paddle.html#t:modify_ldap_error/0","title":"Paddle.modify_ldap_error/0","type":"type"},{"doc":"","ref":"Paddle.html#t:reason/0","title":"Paddle.reason/0","type":"type"},{"doc":"","ref":"Paddle.html#t:search_ldap_error/0","title":"Paddle.search_ldap_error/0","type":"type"},{"doc":"Module used internally by Paddle to manipulate / convert LDAP attributes.","ref":"Paddle.Attributes.html","title":"Paddle.Attributes","type":"module"},{"doc":"Get the given and the generated attributes of a given class object. Examples: iex&gt; Paddle.Attributes . get ( % MyApp.PosixGroup { } ) { :error , :missing_required_attributes , [ :cn ] } iex&gt; Paddle.Attributes . get ( % MyApp.PosixGroup { cn : &quot;myGroup&quot; } ) { :ok , %{ cn : &quot;myGroup&quot; , description : nil , gidNumber : 4 , memberUid : nil , objectClass : &quot;posixGroup&quot; , userPassword : nil } }","ref":"Paddle.Attributes.html#get/1","title":"Paddle.Attributes.get/1","type":"function"},{"doc":"Protocol used to allow some objects (mainly structs) to represent an LDAP entry. Implementing this protocol for your specific classes will enable you to manipulate LDAP entries in an easier way than using DNs (hopefully). If the class you want to implement is simple enough, you might want to use the Paddle.Class.Helper.gen_class_from_schema/3 or Paddle.Class.Helper.gen_class/2 macros. For now, only two &quot;classes&quot; implementing this protocol are provided: Paddle.PosixAccount and Paddle.PosixGroup .","ref":"Paddle.Class.html","title":"Paddle.Class","type":"protocol"},{"doc":"Return a list of attributes to be generated using the given functions. Warning: do not use functions with side effects, as this function may be called even if adding some LDAP entries fails. Example: [uid: &amp;Paddle.PosixAccount.get_next_uid/1] This function must take 1 parameter which will be the current class object (useful if you have interdependent attribute values) and must return the generated value. For example, with %Paddle.PosixGroup{uid: &quot;myUser&quot;, ...} the function will be called like this: Paddle.PosixAccount . get_next_uid ( % Paddle.PosixAccount { uid : &quot;myUser&quot; , ... }","ref":"Paddle.Class.html#generators/1","title":"Paddle.Class.generators/1","type":"function"},{"doc":"Return the parent subDN (where to add / get entries of this type). Example for users: &quot;ou=People&quot; The top base (e.g. &quot;dc=organisation,dc=org&quot; ) must not be specified.","ref":"Paddle.Class.html#location/1","title":"Paddle.Class.location/1","type":"function"},{"doc":"Must return the class or the list of classes which this &quot;object class&quot; belongs to. For example, a posixAccount could have the following object classes: [&quot;account&quot;, &quot;posixAccount&quot;] The &quot;top&quot; class is not required.","ref":"Paddle.Class.html#object_classes/1","title":"Paddle.Class.object_classes/1","type":"function"},{"doc":"Return the list of required attributes for this &quot;class&quot; For example, for the posixAccount class, the following attributes are required: [ :uid , :cn , :uidNumber , :gidNumber , :homeDirectory ]","ref":"Paddle.Class.html#required_attributes/1","title":"Paddle.Class.required_attributes/1","type":"function"},{"doc":"Return the name of the attribute used in the DN to uniquely identify entries. For example, the identifier for an account would be :uid because an account DN would be like: &quot;uid=testuser,ou=People,...&quot;","ref":"Paddle.Class.html#unique_identifier/1","title":"Paddle.Class.unique_identifier/1","type":"function"},{"doc":"","ref":"Paddle.Class.html#t:t/0","title":"Paddle.Class.t/0","type":"type"},{"doc":"A helper module to help generate paddle classes. There is currently two ways of generating paddle classes: Using schema files The simplest way is to find *.schema files which contain definitions of LDAP object classes. You can find them in the /etc/(open)ldap/schema/ directory if you have OpenLDAP installed. If not, you can find most of them here . Then, add the path of these files in the Paddle configuration using the :schema_files key (see the Paddle module toplevel documentation). Finally just call the gen_class_from_schema/3 macro from anywhere outside of a module. Example: require Paddle.Class.Helper Paddle.Class.Helper . gen_class_from_schema MyApp.Room , [ &quot;room&quot; ] , &quot;ou=Rooms&quot; For a description of the parameters and more configuration options, see the gen_class_from_schema/3 macro documentation. Manually describing the class If you're feeling more adventurous you can still use this helper you can also specify by hand each part of the class using the Paddle.Class.Helper.gen_class/2 macro (if that still doesn't satisfy you, you can always look at the Paddle.Class protocol). Example (which is equivalent to the example above): require Paddle.Class.Helper Paddle.Class.Helper . gen_class MyApp.Room , fields : [ :commonName , :roomNumber , :description , :seeAlso , :telephoneNumber ] , unique_identifier : :commonName , object_classes : [ &quot;room&quot; ] , required_attributes : [ :commonName ] , location : &quot;ou=Rooms&quot; The available options are all function names defined and documented in the Paddle.Class protocol, plus the :fields option which defines all the available fields for the given class. Please note that using the :generators option here is discouraged as generators should be inside the module and not elsewhere. Unless you are sure what you are doing is elegant enough, you should define the module yourself instead of using this macro with the :generators option (see the Paddle.Class and the source of this macro for guidelines).","ref":"Paddle.Class.Helper.html","title":"Paddle.Class.Helper","type":"module"},{"doc":"Generate a Paddle class. Generate a Paddle class represented as a struct with the name class_name , and the options options (see the module toplevel documentation ).","ref":"Paddle.Class.Helper.html#gen_class/2","title":"Paddle.Class.Helper.gen_class/2","type":"macro"},{"doc":"Generate a Paddle class from schema files. Generate a Paddle class from one of the schema files passed as configuration with the name class_name , with the given object_classes (can be a binary or a list of binary), at the given location, optionally force specify which field to use as a unique identifier (see Paddle.Class.unique_identifier/1 ), and some optional generators (see Paddle.Class.generators/1 )","ref":"Paddle.Class.Helper.html#gen_class_from_schema/5","title":"Paddle.Class.Helper.gen_class_from_schema/5","type":"macro"},{"doc":"Module used internally by Paddle to manipulate LDAP filters.","ref":"Paddle.Filters.html","title":"Paddle.Filters","type":"module"},{"doc":"Construct a filter that matches a list of objectClasses. Examples: iex&gt; Paddle.Filters . class_filter [ &quot;posixAccount&quot; , &quot;account&quot; ] { :and , [ equalityMatch : { :AttributeValueAssertion , &#39;objectClass&#39; , &#39;posixAccount&#39; } , equalityMatch : { :AttributeValueAssertion , &#39;objectClass&#39; , &#39;account&#39; } ] }","ref":"Paddle.Filters.html#class_filter/1","title":"Paddle.Filters.class_filter/1","type":"function"},{"doc":"Construct a eldap filter from the given keyword list or map. If given an :eldap filter (a tuple), it is returned as is. If given nil , it will return an empty filter ( :eldap.and([]) ). Examples: iex&gt; Paddle.Filters . construct_filter ( uid : &quot;testuser&quot; ) { :equalityMatch , { :AttributeValueAssertion , &#39;uid&#39; , &#39;testuser&#39; } } iex&gt; Paddle.Filters . construct_filter ( %{ uid : &quot;testuser&quot; } ) { :equalityMatch , { :AttributeValueAssertion , &#39;uid&#39; , &#39;testuser&#39; } } iex&gt; Paddle.Filters . construct_filter ( %{ &quot;uid&quot; =&gt; &quot;testuser&quot; } ) { :equalityMatch , { :AttributeValueAssertion , &#39;uid&#39; , &#39;testuser&#39; } } iex&gt; Paddle.Filters . construct_filter ( :eldap . substrings ( &#39;uid&#39; , initial : &#39;b&#39; ) ) { :substrings , { :SubstringFilter , &#39;uid&#39; , [ initial : &#39;b&#39; ] } } iex&gt; Paddle.Filters . construct_filter ( nil ) { :and , [ ] } iex&gt; Paddle.Filters . construct_filter ( [ ] ) { :and , [ ] } iex&gt; Paddle.Filters . construct_filter ( uid : &quot;testuser&quot; , cn : &quot;Test User&quot; ) { :and , [ equalityMatch : { :AttributeValueAssertion , &#39;uid&#39; , &#39;testuser&#39; } , equalityMatch : { :AttributeValueAssertion , &#39;cn&#39; , &#39;Test User&#39; } ] }","ref":"Paddle.Filters.html#construct_filter/1","title":"Paddle.Filters.construct_filter/1","type":"function"},{"doc":"Merge two filters with an &quot;and&quot; operation. Examples: iex&gt; Paddle.Filters . merge_filter ( [ uid : &quot;testuser&quot; ] , [ cn : &quot;Test User&quot; ] ) { :and , [ equalityMatch : { :AttributeValueAssertion , &#39;uid&#39; , &#39;testuser&#39; } , equalityMatch : { :AttributeValueAssertion , &#39;cn&#39; , &#39;Test User&#39; } ] } iex&gt; Paddle.Filters . merge_filter ( [ uid : &quot;testuser&quot; ] , :eldap . substrings ( &#39;cn&#39; , [ initial : &#39;Tes&#39; ] ) ) { :and , [ equalityMatch : { :AttributeValueAssertion , &#39;uid&#39; , &#39;testuser&#39; } , substrings : { :SubstringFilter , &#39;cn&#39; , [ initial : &#39;Tes&#39; ] } ] } iex&gt; Paddle.Filters . merge_filter ( [ uid : &quot;testuser&quot; ] , [ ] ) [ uid : &quot;testuser&quot; ] iex&gt; Paddle.Filters . merge_filter ( [ ] , [ cn : &quot;Test User&quot; ] ) [ cn : &quot;Test User&quot; ] iex&gt; Paddle.Filters . merge_filter ( [ ] , nil ) { :and , [ ] }","ref":"Paddle.Filters.html#merge_filter/2","title":"Paddle.Filters.merge_filter/2","type":"function"},{"doc":"","ref":"Paddle.Filters.html#t:easy_filter/0","title":"Paddle.Filters.easy_filter/0","type":"type"},{"doc":"","ref":"Paddle.Filters.html#t:eldap_filter/0","title":"Paddle.Filters.eldap_filter/0","type":"type"},{"doc":"","ref":"Paddle.Filters.html#t:filter/0","title":"Paddle.Filters.filter/0","type":"type"},{"doc":"","ref":"Paddle.Filters.html#t:t/0","title":"Paddle.Filters.t/0","type":"type"},{"doc":"Module composed of utility functions for translating between :eldap and Paddle representation.","ref":"Paddle.Parsing.html","title":"Paddle.Parsing","type":"module"},{"doc":"Convert an :eldap search result to a Paddle representation. Also see clean_entries/1 Examples: iex&gt; eldap_entry = { :eldap_entry , &#39;uid=testuser,ou=People&#39; , [ { &#39;uid&#39; , [ &#39;testuser&#39; ] } ] } iex&gt; Paddle.Parsing . clean_eldap_search_results ( { :ok , { :eldap_search_result , [ eldap_entry ] , [ ] } } , &#39;&#39; ) { :ok , [ %{ &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] } ] } iex&gt; Paddle.Parsing . clean_eldap_search_results ( { :ok , { :eldap_search_result , [ ] , [ ] } } , &#39;&#39; ) { :error , :noSuchObject } iex&gt; Paddle.Parsing . clean_eldap_search_results ( { :error , :insufficientAccessRights } , &#39;&#39; ) { :error , :insufficientAccessRights } iex&gt; eldap_entry = { :eldap_entry , &#39;uid=testuser,ou=People&#39; , [ { &#39;uid&#39; , [ &#39;testuser&#39; ] } ] } iex&gt; Paddle.Parsing . clean_eldap_search_results ( { :ok , { :eldap_search_result , [ eldap_entry ] , [ ] } } , &#39;ou=People&#39; ) { :ok , [ %{ &quot;dn&quot; =&gt; &quot;uid=testuser&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] } ] }","ref":"Paddle.Parsing.html#clean_eldap_search_results/2","title":"Paddle.Parsing.clean_eldap_search_results/2","type":"function"},{"doc":"Get a binary map representation of several eldap entries. The base argument corresponds to the DN base which should be stripped from the result's &quot;dn&quot; attribute. Example: iex&gt; Paddle.Parsing . clean_entries ( [ { :eldap_entry , &#39;uid=testuser,ou=People&#39; , [ { &#39;uid&#39; , [ &#39;testuser&#39; ] } ] } ] , &#39;&#39; ) [ %{ &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] } ] iex&gt; Paddle.Parsing . clean_entries ( [ { :eldap_entry , &#39;uid=testuser,ou=People&#39; , [ { &#39;uid&#39; , [ &#39;testuser&#39; ] } ] } ] , &#39;ou=People&#39; ) [ %{ &quot;dn&quot; =&gt; &quot;uid=testuser&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] } ]","ref":"Paddle.Parsing.html#clean_entries/2","title":"Paddle.Parsing.clean_entries/2","type":"function"},{"doc":"Get a binary map representation of a single eldap entry. The base_length argument corresponds to the DN base length which should be stripped from the result's &quot;dn&quot; attribute. Example: iex&gt; Paddle.Parsing . clean_entry ( { :eldap_entry , &#39;uid=testuser,ou=People&#39; , [ { &#39;uid&#39; , [ &#39;testuser&#39; ] } ] } , 0 ) %{ &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] } iex&gt; Paddle.Parsing . clean_entry ( { :eldap_entry , &#39;uid=testuser,ou=People&#39; , [ { &#39;uid&#39; , [ &#39;testuser&#39; ] } ] } , 9 ) %{ &quot;dn&quot; =&gt; &quot;uid=testuser&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] }","ref":"Paddle.Parsing.html#clean_entry/2","title":"Paddle.Parsing.clean_entry/2","type":"function"},{"doc":"Construct a DN Erlang string based on a keyword list or a string. Examples: iex&gt; Paddle.Parsing . construct_dn ( uid : &quot;user&quot; , ou : &quot;People&quot; ) &#39;uid=user,ou=People&#39; iex&gt; Paddle.Parsing . construct_dn ( [ { &quot;uid&quot; , &quot;user&quot; } , { &quot;ou&quot; , &quot;People&quot; } ] , &quot;dc=organisation,dc=org&quot; ) &#39;uid=user,ou=People,dc=organisation,dc=org&#39; iex&gt; Paddle.Parsing . construct_dn ( &quot;uid=user,ou=People&quot; , &quot;dc=organisation,dc=org&quot; ) &#39;uid=user,ou=People,dc=organisation,dc=org&#39; Values are escaped. Note: using a map is highly discouraged because the key / values may be reordered and because they can be mistaken for a class object (see Paddle.Class ).","ref":"Paddle.Parsing.html#construct_dn/2","title":"Paddle.Parsing.construct_dn/2","type":"function"},{"doc":"Tranform an LDAP DN to a keyword list. Well, not exactly a keyword list but a list like this: [ { &quot;uid&quot; , &quot;user&quot; } , { &quot;ou&quot; , &quot;People&quot; } , { &quot;dc&quot; , &quot;organisation&quot; } , { &quot;dc&quot; , &quot;org&quot; } ] Example: iex&gt; Paddle.Parsing . dn_to_kwlist ( &quot;uid=user,ou=People,dc=organisation,dc=org&quot; ) [ { &quot;uid&quot; , &quot;user&quot; } , { &quot;ou&quot; , &quot;People&quot; } , { &quot;dc&quot; , &quot;organisation&quot; } , { &quot;dc&quot; , &quot;org&quot; } ]","ref":"Paddle.Parsing.html#dn_to_kwlist/1","title":"Paddle.Parsing.dn_to_kwlist/1","type":"function"},{"doc":"Convert a Paddle entry to a given Paddle class object. Example: iex&gt; entry = %{ &quot;dn&quot; =&gt; &quot;uid=testuser,ou=People&quot; , &quot;uid&quot; =&gt; [ &quot;testuser&quot; ] , &quot;description&quot; =&gt; [ &quot;hello&quot; ] } iex&gt; Paddle.Parsing . entry_to_class_object ( entry , % MyApp.PosixAccount { } ) % MyApp.PosixAccount { cn : nil , description : [ &quot;hello&quot; ] , gecos : nil , gidNumber : nil , homeDirectory : nil , host : nil , l : nil , loginShell : nil , o : nil , ou : nil , seeAlso : nil , uid : [ &quot;testuser&quot; ] , uidNumber : nil , userPassword : nil }","ref":"Paddle.Parsing.html#entry_to_class_object/2","title":"Paddle.Parsing.entry_to_class_object/2","type":"function"},{"doc":"Escape special LDAP characters in a string. Example: iex&gt; Paddle.Parsing . ldap_escape ( &quot;a=b#c \\\\ &quot; ) &#39;a \\\\ =b \\\\ #c \\\\ \\\\ &#39;","ref":"Paddle.Parsing.html#ldap_escape/1","title":"Paddle.Parsing.ldap_escape/1","type":"function"},{"doc":"Wrap things in lists and convert binaries / atoms to charlists. iex&gt; Paddle.Parsing . list_wrap &quot;hello&quot; [ &#39;hello&#39; ] iex&gt; Paddle.Parsing . list_wrap :hello [ &#39;hello&#39; ] iex&gt; Paddle.Parsing . list_wrap [ &quot;hello&quot; , &quot;world&quot; ] [ &#39;hello&#39; , &#39;world&#39; ]","ref":"Paddle.Parsing.html#list_wrap/1","title":"Paddle.Parsing.list_wrap/1","type":"function"},{"doc":"Convert a user-friendly modify operation to an eldap operation. Examples: iex&gt; Paddle.Parsing . mod_convert { :add , { &quot;description&quot; , &quot;This is a description&quot; } } { :ModifyRequest_changes_SEQOF , :add , { :PartialAttribute , &#39;description&#39; , [ &#39;This is a description&#39; ] } } iex&gt; Paddle.Parsing . mod_convert { :delete , &quot;description&quot; } { :ModifyRequest_changes_SEQOF , :delete , { :PartialAttribute , &#39;description&#39; , [ ] } } iex&gt; Paddle.Parsing . mod_convert { :replace , { &quot;description&quot; , &quot;This is a description&quot; } } { :ModifyRequest_changes_SEQOF , :replace , { :PartialAttribute , &#39;description&#39; , [ &#39;This is a description&#39; ] } }","ref":"Paddle.Parsing.html#mod_convert/1","title":"Paddle.Parsing.mod_convert/1","type":"function"},{"doc":"","ref":"Paddle.Parsing.html#t:eldap_dn/0","title":"Paddle.Parsing.eldap_dn/0","type":"type"},{"doc":"","ref":"Paddle.Parsing.html#t:eldap_entry/0","title":"Paddle.Parsing.eldap_entry/0","type":"type"},{"doc":"Module used to parse *.schema files and generate Paddle classes.","ref":"Paddle.SchemaParser.html","title":"Paddle.SchemaParser","type":"module"},{"doc":"Get the attributes names of an object class or a list of object classes. Example: iex&gt; Paddle.SchemaParser . attributes &quot;account&quot; [ :description , :seeAlso , :l , :o , :ou , :host , :uid ] iex&gt; Paddle.SchemaParser . attributes [ &quot;posixAccount&quot; , &quot;account&quot; ] [ :userPassword , :loginShell , :gecos , :description , :cn , :uid , :uidNumber , :gidNumber , :homeDirectory , :seeAlso , :l , :o , :ou , :host ]","ref":"Paddle.SchemaParser.html#attributes/1","title":"Paddle.SchemaParser.attributes/1","type":"function"},{"doc":"Get the required attributes names of an object class or a list of object classes. Example: iex&gt; Paddle.SchemaParser . required_attributes &quot;account&quot; [ :uid ] iex&gt; Paddle.SchemaParser . required_attributes [ &quot;posixAccount&quot; , &quot;account&quot; ] [ :cn , :uid , :uidNumber , :gidNumber , :homeDirectory ]","ref":"Paddle.SchemaParser.html#required_attributes/1","title":"Paddle.SchemaParser.required_attributes/1","type":"function"},{"doc":"Paddle A library simplifying LDAP usage in Elixir projects. Documentation","ref":"readme.html","title":"Paddle","type":"extras"},{"doc":"This version forked from https://github.com/minijackson/paddle in order to solve bug #81 . Neither this version or the upstream version is maintained. You should not use this library for new projects. Unfortunately, there are no good LDAP libraries in Elxir.","ref":"readme.html#forked-version","title":"Paddle - FORKED VERSION","type":"extras"},{"doc":"If you want to communicate with an LDAP server in Elixir, you probably know that there are other libraries out there. However, I didn't find one that suited me: The :eldap library is great, but very low-level, with no high-level features. EctoLdap is very interesting, but I needed the add / modify / delete operations (in fact, I even wanted to do an Ecto adapter at first). Exldap and LDAPEx are both a translation of the LDAP :eldap in Elixir, which is nice, but are still missing some higher-level features.","ref":"readme.html#why-another-ldap-library","title":"Paddle - Why another LDAP library?","type":"extras"},{"doc":"Once installed and configured, it allows you to quickly authenticate users: iex&gt; Paddle . authenticate ( &quot;myUser&quot; , &quot;password&quot; ) :ok Get meaningful information using Paddle.Class structs: iex&gt; Paddle . get % MyApp.PosixAccount { uid : &quot;myUser&quot; } { :ok , [ % MyApp.PosixAccount { cn : [ &quot;My User&quot; ] , description : nil , gecos : [ &quot;My User,,,,&quot; ] , gidNumber : [ &quot;120&quot; ] , homeDirectory : [ &quot;/home/myuser&quot; ] , host : nil , l : nil , loginShell : [ &quot;/bin/bash&quot; ] , o : nil , ou : nil , seeAlso : nil , uid : [ &quot;myUser&quot; ] , uidNumber : [ &quot;500&quot; ] , userPassword : [ &quot;{SSHA}AIzygLSXlArhAMzddUriXQxf7UlkqopP&quot; ] } ] } Or get information just about anything: iex&gt; Paddle . get base : [ ou : &quot;People&quot; ] , filter : [ objectClass : &quot;organizationalUnit&quot; ] { :ok , [ %{ &quot;dn&quot; =&gt; &quot;ou=People,dc=test,dc=com&quot; , &quot;objectClass&quot; =&gt; [ &quot;top&quot; , &quot;organizationalUnit&quot; ] , &quot;ou&quot; =&gt; [ &quot;People&quot; ] } ] } Add, delete, modify operations are supported. If you want to know more, just go to the documentation .","ref":"readme.html#usage","title":"Paddle - Usage","type":"extras"},{"doc":"The package can be installed as: Add paddle to your list of dependencies in mix.exs : def deps do [ { :penguin_paddle , &quot;~&gt; 0.1.0&quot; } ] end Ensure paddle is started before your application: def application do [ applications : [ :penguin_paddle ] ] end Add your configuration in your config files: config :penguin_paddle , Paddle , host : &quot;ldap.my-organisation.org&quot; , base : &quot;dc=myorganisation,dc=org&quot; , ssl : true , port : 636 For more configurations, see the Paddle module docmumentation .","ref":"readme.html#installation","title":"Paddle - Installation","type":"extras"},{"doc":"If you want to test this application, you can use the linux commands described in the .travis.yml file in the before_script block to start a local test LDAP server. Keep in mind that you may need to change the .travis/ldap/slapd.conf for your system by changing some configuration paths. If you want to add some more data to the test server, please feel free to issue a pull request.","ref":"readme.html#testing","title":"Paddle - Testing","type":"extras"}]